%Gwny skrypt uywany do oceny jakoci cech
%W skrypcie najpierw przygotowywany jest zbir danych,
%Nastpnie odpalana jest 30xCV z drzewami decyzji
%Nastpnie wyniki s zapisywane katalogu "saveDir" osobno wyniki w postaci
%RMSE do plikw excela, oraz w postaci plikw .mat komplet danych w tym
%RMSE, std, zbudowane drzew, wspczynniki istotnoci cech (Imp), oraz
%szczegowe wyniki z poszczeglnych CV do robienia testw statystycznych
%Uwaga parametrami ponizej definiujemy ktre elementy bd naleay do zbioru danych tj. z jakich atrybutw bdzie si skada:
%   useCompressionFM jeli =1 to znaczy e bierzemy metacechy bazujce na
%                       kompresji
%   compressionFM - jeli istnieje to okrelamy ktre z atrybutw
%   bazujcych na kompresji bd uyte. Jeli zmiennej nie ma to domylnie
%   wszystkie atrybuty.  Zmienna ma posta cell array z nazwami kolumn do
%   zachowania
%usePaReNFM jeli =1 to bierzemy metadane z PaReN, jeli 0 to nie bierzemy
%tych danych. Jeli obie tj. usePaReNFM=1 i useCompressionF =1 to nastpuje
%zczenie obydwu zbiorw danych tak e mamy meta deskryptory zarwno z
%kompresji jak i PaReN'a
%
%clc;
clear;
Global_Paths;
saveDir = 'MetaDatasets\results';
for datasetType = 1:4
    disp(['=========================== Dataset type:' num2str(datasetType) '====================='])
    switch datasetType
        case 1
            useCompressionFM = 1;
            compressionFM = [];
            usePaReNFM = 0;
            noKNN = 0; %Wether in PaReN+CMP dataset kNN attribute of PaReN is kept. If =1 then it is removed (in theory it is replaced by enn)
        case 2
            useCompressionFM = 1;
            compressionFM = {'compression_ENN','compression_IB2'};
            usePaReNFM = 0;
            noKNN = 0; %Wether in PaReN+CMP dataset kNN attribute of PaReN is kept. If =1 then it is removed (in theory it is replaced by enn)
        case 3
            useCompressionFM = 1;
            compressionFM = {'compression_ENN','compression_IB2'};
            usePaReNFM = 1;
            noKNN = 0; %Wether in PaReN+CMP dataset kNN attribute of PaReN is kept. If =1 then it is removed (in theory it is replaced by enn)
        case 4
            useCompressionFM = 0;
            compressionFM = [];
            usePaReNFM = 1;
            noKNN = 0; %Wether in PaReN+CMP dataset kNN attribute of PaReN is kept. If =1 then it is removed (in theory it is replaced by enn)
        case 5
            useCompressionFM = 1;
            compressionFM = {'compression_ENN','compression_IB2'};
            usePaReNFM = 1;
            noKNN = 1; %Wether in PaReN+CMP dataset kNN attribute of PaReN is kept. If =1 then it is removed (in theory it is replaced by enn)
    end
    %cm = matlabTree({'method','regression','pureLevel',5});
    %cm = NewMatlabTree({'Type','regression','SplitCriterion','mse','PruneCriterion','mse'});
    %cm = EnsembleMatlab({'method','LSBoost','NLearn',30,'Type','regression'});
    %cm = EnsembleMatlab({'method','Bag','NLearn',40,'Type','regression'});
    
    models = {'kNN','SVM','RF'};
    results = [];
    resultsFileSufix = '_Model_Ensemble';
    if noKNN
        resultsFileSufix = [resultsFileSufix '_noKNN'];
    end
    results = [];
    for trees = 10:10:60        
        cm = EnsembleMatlab({'method','Bag','NLearn',trees,'Type','regression'});
        for modelID = 1:length(models)
            model = models{modelID};
            disp(['================= Processing ' model ' dataset:' num2str(datasetType) '=================']);
            %%% Reading IRIS data
            %
            fileName = [];
            if useCompressionFM>0
                fileName = 'CmpAll';
                t1 = readtable(['MetaDatasets\Compression_' model '_All(80datasets).csv'],'delimiter',';');
                if exist('compressionFM','var')&&~isempty(compressionFM)
                    fileName = 'CmpSel';
                    for i=1:length(compressionFM)
                        tmp{i} = t1.(compressionFM{i});
                    end;
                    t1 = table(t1.dataset, tmp{:}, t1.acc,'VariableNames',{'dataset', compressionFM{:} ,'acc'});
                    %t1 = table(t1.dataset, t1.compression_ENN, t1.compression_IB2, t1.acc,'VariableNames',{'dataset','compression_ENN','compression_IB2','acc'});
                    %t1 = table(t1.dataset, t1.compression_ENN, t1.compression_CNN, t1.acc,'VariableNames',{'dataset','compression_ENN','compression_CNN','acc'});
                end
                t1.Properties.RowNames = t1.dataset;
                t1.dataset = [];
                t2=t1;
            end;
            if usePaReNFM
                fileName = ['PaReN_' fileName ];
                t1 = readtable(['MetaDatasets\PaReN_' model '_All(80datasets).csv'],'delimiter',';');
                t1.std = [];
                if noKNN
                    t1.knn = [];
                end;
                t1.Properties.RowNames = t1.dataset;
                t1.dataset = [];
            end
            
            %}
            if useCompressionFM>0 && usePaReNFM>0
                t1 = join(t1,t2,'Keys','RowNames','KeepOneCopy','acc');
            end;
            
            t1 = sortrows(t1,'RowNames');
            
            yId1 = strcmp(t1.Properties.VariableNames,'acc');
            %xId1 = strcmp(t1.Properties.VariableNames,'knn');
            xId1 = ~yId1;
            attrNames = t1.Properties.VariableNames(xId1);            
            yId1 = strcmp(t1.Properties.VariableNames,'acc');
            
            X1 = table2array(t1(:,xId1));
            Y1 = table2array(t1(:, yId1));
            d=data(X1,Y1);
            %Building model
            [ai,bi] = train(cm,d);
            tt = [];
            if isa(cm,'NewMatlabTree') || isa(cm,'EnsembleMatlab')
                imp=predictorImportance(bi.child);
                [impS,impID]=sort(imp);
                tt = table(impS',attrNames(impID)','VariableNames',{'Imp','Name'});
            end;
            %Starting CV
            cmCV=cv(cm,{'folds',10,'balanced',0,'repeats',3});
            rng('default');
            [a,cmCV]=train(cmCV,d);
            res = get_mean(a,'rmse');
            %get_mean(a,'quadratic_loss')
            perf = res.child{1}.Y;
            %tree1 = classregtree(X1,Y1,'names',t1.Properties.VariableNames(~yId1),'PureLevel',20);
            %tree1 = classregtree(X1,Y1,'names',t1.Properties.VariableNames(~yId1));
            %tree1 = classregtree(X1,Y1,'names',t1.Properties.VariableNames(xId1));
            resultsTmp = table({model},perf(1),perf(2),{tt},{bi},{a},trees,'VariableNames',{'model','RMSE','std','imp','tree','res','trees'});
            results = [results;resultsTmp];
        end;
        %Saving resutls
        resSave = results;
        resSave.imp = [];
        resSave.tree = [];
        writetable(resSave,[saveDir filesep fileName resultsFileSufix '.xlsx']);
        save([saveDir filesep fileName resultsFileSufix],'results')
    end;
end;